[Spice-devel] [PATCH spice 3/3] syntax-check: Update gnufiles
Frediano Ziglio
fziglio at redhat.com
Fri Nov 18 12:03:52 UTC 2016
>
> Fix make check, otherwise it fails on
> GEN public-submodule-commit
> Stopping at 'spice-common'; script returned non-zero status.
> maint.mk: found non-public submodule commit
> ---
> GNUmakefile | 25 ++-
> maint.mk | 555
> ++++++++++++++++++++++++++++++++++++++----------------------
> 2 files changed, 366 insertions(+), 214 deletions(-)
>
> diff --git a/GNUmakefile b/GNUmakefile
> index ca88b6b..a869da5 100644
> --- a/GNUmakefile
> +++ b/GNUmakefile
> @@ -1,11 +1,11 @@
> -# Having a separate GNUmakefile lets me `include' the dynamically
> +# Having a separate GNUmakefile lets me 'include' the dynamically
> # generated rules created via cfg.mk (package-local configuration)
> # as well as maint.mk (generic maintainer rules).
> # This makefile is used only if you run GNU Make.
> # It is necessary if you want to build targets usually of interest
> # only to the maintainer.
>
> -# Copyright (C) 2001, 2003, 2006-2011 Free Software Foundation, Inc.
> +# Copyright (C) 2001, 2003, 2006-2016 Free Software Foundation, Inc.
>
> # This program is free software: you can redistribute it and/or modify
> # it under the terms of the GNU General Public License as published by
> @@ -20,20 +20,10 @@
> # You should have received a copy of the GNU General Public License
> # along with this program. If not, see <http://www.gnu.org/licenses/>.
>
> -# Systems where /bin/sh is not the default shell need this. The $(shell)
> -# command below won't work with e.g. stock DOS/Windows shells.
> -ifeq ($(wildcard /bin/s[h]),/bin/sh)
> -SHELL = /bin/sh
> -else
> -# will be used only with the next shell-test line, then overwritten
> -# by a configured-in value
> -SHELL = sh
> -endif
> -
> # If the user runs GNU make but has not yet run ./configure,
> # give them a diagnostic.
> -_have-Makefile := $(shell test -f Makefile && echo yes)
> -ifeq ($(_have-Makefile),yes)
> +_gl-Makefile := $(wildcard [M]akefile)
> +ifneq ($(_gl-Makefile),)
>
> # Make tar archive easier to reproduce.
> export TAR_OPTIONS = --owner=0 --group=0 --numeric-owner
> @@ -101,6 +91,11 @@ srcdir = .
>
> # The package can override .DEFAULT_GOAL to run actions like autoreconf.
> -include ./cfg.mk
> +
> +# Allow cfg.mk to override these.
> +_build-aux ?= build-aux
> +_autoreconf ?= autoreconf -v
> +
> include ./maint.mk
>
> ifeq ($(.DEFAULT_GOAL),abort-due-to-no-makefile)
> @@ -109,7 +104,7 @@ endif
>
> abort-due-to-no-makefile:
> @echo There seems to be no Makefile in this directory. 1>&2
> - @echo "You must run ./configure before running \`make'." 1>&2
> + @echo "You must run ./configure before running 'make'." 1>&2
> @exit 1
>
> endif
> diff --git a/maint.mk b/maint.mk
> index 1eb5217..c32f8b6 100644
> --- a/maint.mk
> +++ b/maint.mk
> @@ -2,7 +2,7 @@
> # This Makefile fragment tries to be general-purpose enough to be
> # used by many projects via the gnulib maintainer-makefile module.
>
> -## Copyright (C) 2001-2011 Free Software Foundation, Inc.
> +## Copyright (C) 2001-2016 Free Software Foundation, Inc.
> ##
> ## This program is free software: you can redistribute it and/or modify
> ## it under the terms of the GNU General Public License as published by
> @@ -21,12 +21,27 @@
> # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
> ME := maint.mk
>
> -# Diagnostic for continued use of deprecated variable.
> -# Remove in 2013
> -ifneq ($(build_aux),)
> - $(error "$(ME): \
> -set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
> -endif
> +# Helper variables.
> +_empty =
> +_sp = $(_empty) $(_empty)
> +
> +# _equal,S1,S2
> +# ------------
> +# If S1 == S2, return S1, otherwise the empty string.
> +_equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
> +
> +# member-check,VARIABLE,VALID-VALUES
> +# ----------------------------------
> +# Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
> +# return it. Die otherwise.
> +member-check = \
> + $(strip \
> + $(if $($(1)), \
> + $(if $(findstring $(_sp),$($(1))), \
> + $(error invalid $(1): '$($(1))', expected $(2)), \
> + $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)$(_sp)), \
> + $(error invalid $(1): '$($(1))', expected $(2)))), \
> + $(error $(1) undefined)))
>
> # Do not save the original name or timestamp in the .tar.gz file.
> # Use --rsyncable if available.
> @@ -52,18 +67,18 @@ _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
> # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
> # when $(srcdir) is not ".".
> ifeq ($(srcdir),.)
> -_prepend_srcdir_prefix =
> + _prepend_srcdir_prefix =
> else
> -_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
> + _prepend_srcdir_prefix = | $(SED) 's|^|$(srcdir)/|'
> endif
>
> # In order to be able to consistently filter "."-relative names,
> # (i.e., with no $(srcdir) prefix), this definition is careful to
> # remove any $(srcdir) prefix, and to restore what it removes.
> _sc_excl = \
> - $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
> + $(or $(exclude_file_name_regexp--$@),^$$)
> VC_LIST_EXCEPT = \
> - $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
> + $(VC_LIST) | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
> | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
> else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
> | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
> @@ -78,32 +93,41 @@ VERSION_REGEXP = $(subst .,\.,$(VERSION))
> PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
>
> ifeq ($(VC),$(GIT))
> -this-vc-tag = v$(VERSION)
> -this-vc-tag-regexp = v$(VERSION_REGEXP)
> + this-vc-tag = v$(VERSION)
> + this-vc-tag-regexp = v$(VERSION_REGEXP)
> else
> -tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
> -tag-this-version = $(subst .,_,$(VERSION))
> -this-vc-tag = $(tag-package)-$(tag-this-version)
> -this-vc-tag-regexp = $(this-vc-tag)
> + tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
> + tag-this-version = $(subst .,_,$(VERSION))
> + this-vc-tag = $(tag-package)-$(tag-this-version)
> + this-vc-tag-regexp = $(this-vc-tag)
> endif
> my_distdir = $(PACKAGE)-$(VERSION)
>
> # Old releases are stored here.
> release_archive_dir ?= ../release
>
> +# If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
> +# But overwrite VERSION.
> +ifdef RELEASE
> + VERSION := $(word 1, $(RELEASE))
> + RELEASE_TYPE ?= $(word 2, $(RELEASE))
> +endif
> +
> +# Validate and return $(RELEASE_TYPE), or die.
> +RELEASE_TYPES = alpha beta stable
> +release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
> +
> # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
> # Use alpha.gnu.org for alpha and beta releases.
> # Use ftp.gnu.org for stable releases.
> gnu_ftp_host-alpha = alpha.gnu.org
> gnu_ftp_host-beta = alpha.gnu.org
> gnu_ftp_host-stable = ftp.gnu.org
> -gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
> +gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
>
> -ifeq ($(gnu_rel_host),ftp.gnu.org)
> -url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
> -else
> -url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
> -endif
> +url_dir_list ?= $(if $(call _equal,$(gnu_rel_host),ftp.gnu.org), \
> + http://ftpmirror.gnu.org/$(PACKAGE), \
> + ftp://$(gnu_rel_host)/gnu/$(PACKAGE))
>
> # Override this in cfg.mk if you are using a different format in your
> # NEWS file.
> @@ -124,17 +148,18 @@ export LC_ALL = C
> ## Sanity checks. ##
> ## --------------- ##
>
> -_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
> +ifneq ($(_gl-Makefile),)
> +_cfg_mk := $(wildcard $(srcdir)/cfg.mk)
>
> -# Collect the names of rules starting with `sc_'.
> -syntax-check-rules := $(sort $(shell sed -n
> 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
> - $(srcdir)/$(ME) $(_cfg_mk)))
> +# Collect the names of rules starting with 'sc_'.
> +syntax-check-rules := $(sort $(shell $(SED) -n \
> + 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME) $(_cfg_mk)))
> .PHONY: $(syntax-check-rules)
>
> ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
> -local-checks-available += $(syntax-check-rules)
> + local-checks-available += $(syntax-check-rules)
> else
> -local-checks-available += no-vc-detected
> + local-checks-available += no-vc-detected
> no-vc-detected:
> @echo "No version control files detected; skipping syntax check"
> endif
> @@ -165,6 +190,7 @@ local-check := \
> $(filter-out $(local-checks-to-skip), $(local-checks-available)))
>
> syntax-check: $(local-check)
> +endif
>
> # _sc_search_regexp
> #
> @@ -178,11 +204,20 @@ syntax-check: $(local-check)
> # Regular expression (ERE) denoting either a forbidden construct
> # or a required construct. Those arguments are exclusive.
> #
> +# exclude
> +#
> +# Regular expression (ERE) denoting lines to ignore that matched
> +# a prohibit construct. For example, this can be used to exclude
> +# comments that mention why the nearby code uses an alternative
> +# construct instead of the simpler prohibited construct.
> +#
> # in_vc_files | in_files
> #
> -# grep-E-style regexp denoting the files to check. If no files
> -# are specified the default are all the files that are under
> -# version control.
> +# grep-E-style regexp selecting the files to check. For in_vc_files,
> +# the regexp is used to select matching files from the list of all
> +# version-controlled files; for in_files, it's from the names printed
> +# by "find $(srcdir)". When neither is specified, use all files that
> +# are under version control.
> #
> # containing | non_containing
> #
> @@ -212,6 +247,17 @@ syntax-check: $(local-check)
> # when filtering by name via in_files, we explicitly filter out matching
> # names here as well.
>
> +# Initialize each, so that envvar settings cannot interfere.
> +export require =
> +export prohibit =
> +export exclude =
> +export in_vc_files =
> +export in_files =
> +export containing =
> +export non_containing =
> +export halt =
> +export with_grep_options =
> +
> # By default, _sc_search_regexp does not ignore case.
> export ignore_case =
> _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
> @@ -221,15 +267,6 @@ define _sc_say_and_exit
> { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
> endef
>
> -# _sc_search_regexp used to be named _prohibit_regexp. However,
> -# upgrading to the new definition and leaving the old name undefined
> -# would usually convert each custom rule using $(_prohibit_regexp)
> -# (usually defined in cfg.mk) into a no-op. This definition ensures
> -# that people know right away if they're still using the old name.
> -# FIXME: remove in 2012.
> -_prohibit_regexp = \
> - $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and
> adapt')
> -
> define _sc_search_regexp
> dummy=; : so we do not need a semicolon before each use; \
> \
> @@ -240,6 +277,9 @@ define _sc_search_regexp
> test -z "$$prohibit" && test -z "$$require" \
> && { msg='Should specify either prohibit or require' \
> $(_sc_say_and_exit) } || :; \
> + test -z "$$prohibit" && test -n "$$exclude" \
> + && { msg='Use of exclude requires a prohibit pattern' \
> + $(_sc_say_and_exit) } || :; \
> test -n "$$in_vc_files" && test -n "$$in_files" \
> && { msg='Cannot specify both in_vc_files and in_files' \
> $(_sc_say_and_exit) } || :; \
> @@ -249,7 +289,7 @@ define _sc_search_regexp
> : Filter by file name; \
> if test -n "$$in_files"; then \
> files=$$(find $(srcdir) | grep -E "$$in_files" \
> - | grep -Ev '$(exclude_file_name_regexp--$@)'); \
> + | grep -Ev '$(_sc_excl)'); \
> else \
> files=$$($(VC_LIST_EXCEPT)); \
> if test -n "$$in_vc_files"; then \
> @@ -267,6 +307,7 @@ define _sc_search_regexp
> if test -n "$$files"; then \
> if test -n "$$prohibit"; then \
> grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
> + | grep -vE "$${exclude:-^$$}" \
> && { msg="$$halt" $(_sc_say_and_exit) } || :; \
> else \
> grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
> @@ -285,17 +326,17 @@ sc_avoid_if_before_free:
> exit 1; } || :
>
> sc_cast_of_argument_to_free:
> - @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
> + @prohibit='\<free *\( *\(' halt="don't cast free argument" \
> $(_sc_search_regexp)
>
> sc_cast_of_x_alloc_return_value:
> @prohibit='\*\) *x(m|c|re)alloc\>' \
> - halt='don'\''t cast x*alloc return value' \
> + halt="don't cast x*alloc return value" \
> $(_sc_search_regexp)
>
> sc_cast_of_alloca_return_value:
> @prohibit='\*\) *alloca\>' \
> - halt='don'\''t cast alloca return value' \
> + halt="don't cast alloca return value" \
> $(_sc_search_regexp)
>
> sc_space_tab:
> @@ -303,7 +344,7 @@ sc_space_tab:
> halt='found SPACE-TAB sequence; remove the SPACE' \
> $(_sc_search_regexp)
>
> -# Don't use *scanf or the old ato* functions in `real' code.
> +# Don't use *scanf or the old ato* functions in "real" code.
> # They provide no error checking mechanism.
> # Instead, use strto* functions.
> sc_prohibit_atoi_atof:
> @@ -312,12 +353,20 @@ sc_prohibit_atoi_atof:
> $(_sc_search_regexp)
>
> # Use STREQ rather than comparing strcmp == 0, or != 0.
> +sp_ = strcmp *\(.+\)
> sc_prohibit_strcmp:
> - @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
> - $$($(VC_LIST_EXCEPT)) \
> - | grep -vE ':# *define STRN?EQ\(' && \
> - { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
> - 1>&2; exit 1; } || :
> + @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
> + exclude='# *define STRN?EQ\(' \
> + halt='replace strcmp calls above with STREQ/STRNEQ' \
> + $(_sc_search_regexp)
> +
> +# Really. You don't want to use this function.
> +# It may fail to NUL-terminate the destination,
> +# and always NUL-pads out to the specified length.
> +sc_prohibit_strncpy:
> + @prohibit='\<strncpy *\(' \
> + halt='do not use strncpy, period' \
> + $(_sc_search_regexp)
>
> # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
> # Convert all uses automatically, via these two commands:
> @@ -330,20 +379,21 @@ sc_prohibit_strcmp:
> # | xargs --no-run-if-empty \
> # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
> sc_prohibit_magic_number_exit:
> - @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
> - halt='use EXIT_* values rather than magic number' \
> + @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]' \
> + exclude='exit \(77\)|error ?\(((0|77),|[^,]*)' \
> + halt='use EXIT_* values rather than magic number' \
> $(_sc_search_regexp)
>
> # Using EXIT_SUCCESS as the first argument to error is misleading,
> -# since when that parameter is 0, error does not exit. Use `0' instead.
> +# since when that parameter is 0, error does not exit. Use '0' instead.
> sc_error_exit_success:
> @prohibit='error *\(EXIT_SUCCESS,' \
> in_vc_files='\.[chly]$$' \
> halt='found error (EXIT_SUCCESS' \
> $(_sc_search_regexp)
>
> -# `FATAL:' should be fully upper-cased in error messages
> -# `WARNING:' should be fully upper-cased, or fully lower-cased
> +# "FATAL:" should be fully upper-cased in error messages
> +# "WARNING:" should be fully upper-cased, or fully lower-cased
> sc_error_message_warn_fatal:
> @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
> | grep -E '"Warning|"Fatal|"fatal' && \
> @@ -387,17 +437,26 @@ sc_require_config_h:
> halt='the above files do not include <config.h>' \
> $(_sc_search_regexp)
>
> +# Print each file name for which the first #include does not match
> +# $(config_h_header). Like grep -m 1, this only looks at the first match.
> +perl_config_h_first_ = \
> + -e 'BEGIN {$$ret = 0}' \
> + -e 'if (/^\# *include\b/) {' \
> + -e ' if (not m{^\# *include $(config_h_header)}) {' \
> + -e ' print "$$ARGV\n";' \
> + -e ' $$ret = 1;' \
> + -e ' }' \
> + -e ' \# Move on to next file after first include' \
> + -e ' close ARGV;' \
> + -e '}' \
> + -e 'END {exit $$ret}'
> +
> # You must include <config.h> before including any other header file.
> # This can possibly be via a package-specific header, if given by cfg.mk.
> sc_require_config_h_first:
> - @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
> - fail=0; \
> - for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
> - grep '^# *include\>' $$i | sed 1q \
> - | grep -E '^# *include $(config_h_header)' > /dev/null \
> - || { echo $$i; fail=1; }; \
> - done; \
> - test $$fail = 1 && \
> + @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
> + files=$$($(VC_LIST_EXCEPT) | grep '\.c$$') && \
> + perl -n $(perl_config_h_first_) $$files || \
> { echo '$(ME): the above files include some other header' \
> 'before <config.h>' 1>&2; exit 1; } || :; \
> else :; \
> @@ -413,8 +472,8 @@ sc_prohibit_HAVE_MBRTOWC:
> # re: a regular expression that matches IFF something provided by $h is
> used.
> define _sc_header_without_use
> dummy=; : so we do not need a semicolon before each use; \
> - h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
> - if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
> + h_esc=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`; \
> + if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
> files=$$(grep -l '^# *include '"$$h_esc" \
> $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
> grep -LE "$$re" $$files | grep . && \
> @@ -442,7 +501,8 @@ sc_prohibit_quotearg_without_use:
>
> # Don't include quote.h unless you use one of its functions.
> sc_prohibit_quote_without_use:
> - @h='quote.h' re='\<quote(_n)? *\(' $(_sc_header_without_use)
> + @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
> + $(_sc_header_without_use)
>
> # Don't include this header unless you use one of its functions.
> sc_prohibit_long_options_without_use:
> @@ -511,7 +571,7 @@ sc_prohibit_same_without_use:
>
> sc_prohibit_hash_pjw_without_use:
> @h='hash-pjw.h' \
> - re='\<hash_pjw *\(' \
> + re='\<hash_pjw\>' \
> $(_sc_header_without_use)
>
> sc_prohibit_safe_read_without_use:
> @@ -525,7 +585,7 @@ sc_prohibit_argmatch_without_use:
>
> sc_prohibit_canonicalize_without_use:
> @h='canonicalize.h' \
> -
> re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)'
> \
> +
> re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)'
> \
> $(_sc_header_without_use)
>
> sc_prohibit_root_dev_ino_without_use:
> @@ -535,7 +595,7 @@ sc_prohibit_root_dev_ino_without_use:
>
> sc_prohibit_openat_without_use:
> @h='openat.h' \
> -
> re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>'
> \
> +
> re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>'
> \
> $(_sc_header_without_use)
>
> # Prohibit the inclusion of c-ctype.h without an actual use.
> @@ -545,8 +605,6 @@ sc_prohibit_c_ctype_without_use:
> @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
> $(_sc_header_without_use)
>
> -_empty =
> -_sp = $(_empty) $(_empty)
> # The following list was generated by running:
> # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and
> print' \
> # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
> @@ -602,8 +660,7 @@ sc_prohibit_strings_without_use:
> # Get the list of symbol names with this:
> # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
> _intprops_names = \
> - TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
> - TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
> + TYPE_IS_INTEGER TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
> INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
> INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
> INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
> @@ -660,15 +717,6 @@ sc_changelog:
> $(_sc_search_regexp)
>
> # Ensure that each .c file containing a "main" function also
> -# calls set_program_name.
> -sc_program_name:
> - @require='set_program_name *\(m?argv\[0\]\);' \
> - in_vc_files='\.c$$' \
> - containing='\<main *(' \
> - halt='the above files do not call set_program_name' \
> - $(_sc_search_regexp)
> -
> -# Ensure that each .c file containing a "main" function also
> # calls bindtextdomain.
> sc_bindtextdomain:
> @require='bindtextdomain *\(' \
> @@ -696,11 +744,10 @@ sc_require_test_exit_idiom:
> exit 1; } || :; \
> fi
>
> -exclude_file_name_regexp--sc_trailing_blank =
> \.ico$$|\.bmp$$|\.odt$$|\.png$$
> -
> sc_trailing_blank:
> @prohibit='[ ]$$' \
> halt='found trailing blank(s)' \
> + exclude='^Binary file .* matches$$' \
> $(_sc_search_regexp)
>
> # Match lines like the following, but where there is only one space
> @@ -719,12 +766,10 @@ _gl_translatable_diag_func_re ?= error
> # Look for diagnostics that aren't marked for translation.
> # This won't find any for which error's format string is on a separate line.
> sc_unmarked_diagnostics:
> - @grep -nE \
> - '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
> - $$($(VC_LIST_EXCEPT)) \
> - | grep -Ev '(_|ngettext ?)\(' && \
> - { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
> - exit 1; } || :
> + @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
> + exclude='(_|ngettext ?)\(' \
> + halt='found unmarked diagnostic(s)' \
> + $(_sc_search_regexp)
>
> # Avoid useless parentheses like those in this example:
> # #if defined (SYMBOL) || defined (SYM2)
> @@ -738,7 +783,7 @@ sc_useless_cpp_parens:
> # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
> # requires the gnulib module that guarantees the usability of that header.
> gl_assured_headers_ = \
> - cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
> + cd $(gnulib_dir)/lib && echo *.in.h|$(SED) 's/\.in\.h//g'
>
> # Convert the list of names to upper case, and replace each space with "|".
> az_ = abcdefghijklmnopqrstuvwxyz
> @@ -757,6 +802,11 @@ sc_prohibit_always_true_header_tests:
> ' with the corresponding gnulib module, they are always true') \
> $(_sc_search_regexp)
>
> +sc_prohibit_defined_have_decl_tests:
> + @prohibit='(#[ ]*ifn?def|\<defined)\>[ (]+HAVE_DECL_' \
> + halt='HAVE_DECL macros are always defined' \
> + $(_sc_search_regexp)
> +
> # ==================================================================
> gl_other_headers_ ?= \
> intprops.h \
> @@ -784,7 +834,7 @@ define def_sym_regex
> && perl -lne '$(gl_extract_significant_defines_)' $$f; \
> done; \
> ) | sort -u \
> - | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
> + | $(SED) 's/^/^ *# *(define|undef) */;s/$$/\\>/'
> endef
>
> # Don't define macros that we already get from gnulib header files.
> @@ -849,7 +899,7 @@ sc_prohibit_cvs_keyword:
> #
> # This is a perl script that is expected to be the single-quoted argument
> # to a command-line "-le". The remaining arguments are file names.
> -# Print the name of each file that ends in exactly one newline byte.
> +# Print the name of each file that does not end in exactly one newline byte.
> # I.e., warn if there are blank lines (2 or more newlines), or if the
> # last byte is not a newline. However, currently we don't complain
> # about any file that contains exactly one byte.
> @@ -903,8 +953,13 @@ perl_filename_lineno_text_ = \
> -e ' print "$$ARGV:$$n:$$v\n";' \
> -e ' }'
>
> +prohibit_doubled_words_ = \
> + the then in an on if is it but for or at and do to
> +# expand the regex before running the check to avoid using expensive
> captures
> +prohibit_doubled_word_expanded_ = \
> + $(join $(prohibit_doubled_words_),$(addprefix
> \s+,$(prohibit_doubled_words_)))
> prohibit_doubled_word_RE_ ?= \
> - /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
> + /\b(?:$(subst $(_sp),|,$(prohibit_doubled_word_expanded_)))\b/gims
> prohibit_doubled_word_ = \
> -e 'while ($(prohibit_doubled_word_RE_))' \
> $(perl_filename_lineno_text_)
> @@ -922,8 +977,15 @@ sc_prohibit_doubled_word:
> # A regular expression matching undesirable combinations of words like
> # "can not"; this matches them even when the two words appear on different
> # lines, but not when there is an intervening delimiter like "#" or "*".
> +# Similarly undesirable, "See @xref{...}", since an @xref should start
> +# a sentence. Explicitly prohibit any prefix of "see" or "also".
> +# Also prohibit a prefix matching "\w+ +".
> +# @pxref gets the same see/also treatment and should be parenthesized;
> +# presume it must *not* start a sentence.
> +bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
> +bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
> prohibit_undesirable_word_seq_RE_ ?= \
> - /\bcan\s+not\b/gims
> + /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
> prohibit_undesirable_word_seq_ = \
> -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
> $(perl_filename_lineno_text_)
> @@ -938,6 +1000,14 @@ sc_prohibit_undesirable_word_seq:
> | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
> && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
>
> +# Except for shell files and for loops, double semicolon is probably a
> mistake
> +sc_prohibit_double_semicolon:
> + @prohibit='; *;[ {} \]*(/[/*]|$$)' \
> + in_vc_files='\.[chly]$$' \
> + exclude='\bfor *\(.*\)' \
> + halt="Double semicolon detected" \
> + $(_sc_search_regexp)
> +
> _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
> _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
> # Using test's -a and -o operators is not portable.
> @@ -985,18 +1055,18 @@ sc_redundant_const:
> $(_sc_search_regexp)
>
> sc_const_long_option:
> - @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
> - | grep -Ev 'const struct option|struct option const' && { \
> - echo 1>&2 '$(ME): add "const" to the above declarations'; \
> - exit 1; } || :
> + @prohibit='^ *static.*struct option ' \
> + exclude='const struct option|struct option const' \
> + halt='add "const" to the above declarations' \
> + $(_sc_search_regexp)
>
> NEWS_hash = \
> - $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
> + $$($(SED) -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
> $(srcdir)/NEWS \
> | perl -0777 -pe \
> 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
> | md5sum - \
> - | sed 's/ .*//')
> + | $(SED) 's/ .*//')
>
> # Ensure that we don't accidentally insert an entry into an old NEWS block.
> sc_immutable_NEWS:
> @@ -1026,15 +1096,15 @@ update-NEWS-hash: NEWS
> # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
> _makefile_at_at_check_exceptions ?=
> sc_makefile_at_at_check:
> - @perl -ne '/\@[A-Z_0-9]+\@/' \
> - -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/' \
> + @perl -ne '/\@\w+\@/' \
> + -e ' && !/(\w+)\s+=.*\@\1\@$$/' \
> -e ''$(_makefile_at_at_check_exceptions) \
> -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
> $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
> && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
>
> news-check: NEWS
> - if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
> + $(AM_V_GEN)if $(SED) -n $(news-check-lines-spec)p $< \
> | grep -E $(news-check-regexp) >/dev/null; then \
> :; \
> else \
> @@ -1058,30 +1128,34 @@ fix_po_file_diag = \
> 'you have changed the set of files with translatable diagnostics;\n\
> apply the above patch\n'
>
> -# Verify that all source files using _() are listed in po/POTFILES.in.
> +# Generate a list of files in which to search for translatable strings.
> +perl_translatable_files_list_ = \
> + -e 'foreach $$file (@ARGV) {' \
> + -e ' \# Consider only file extensions with one or two letters' \
> + -e ' $$file =~ /\...?$$/ or next;' \
> + -e ' \# Ignore m4 and mk files' \
> + -e ' $$file =~ /\.m[4k]$$/ and next;' \
> + -e ' \# Ignore a .c or .h file with a corresponding .l or .y file' \
> + -e ' $$file =~ /(.+)\.[ch]$$/ && (-e "$${1}.l" || -e "$${1}.y")' \
> + -e ' and next;' \
> + -e ' \# Skip unreadable files' \
> + -e ' -r $$file or next;' \
> + -e ' print "$$file ";' \
> + -e '}'
> +
> +# Verify that all source files using _() (more specifically, files that
> +# match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
> po_file ?= $(srcdir)/po/POTFILES.in
> generated_files ?= $(srcdir)/lib/*.[ch]
> +_gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
> sc_po_check:
> @if test -f $(po_file); then \
> grep -E -v '^(#|$$)' $(po_file) \
> | grep -v '^src/false\.c$$' | sort > $@-1; \
> - files=; \
> - for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
> - test -r $$file || continue; \
> - case $$file in \
> - *.m4|*.mk) continue ;; \
> - *.?|*.??) ;; \
> - *) continue;; \
> - esac; \
> - case $$file in \
> - *.[ch]) \
> - base=`expr " $$file" : ' \(.*\)\..'`; \
> - { test -f $$base.l || test -f $$base.y; } && continue;; \
> - esac; \
> - files="$$files $$file"; \
> - done; \
> - grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
> - | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
> + files=$$(perl $(perl_translatable_files_list_) \
> + $$($(VC_LIST_EXCEPT)) $(generated_files)); \
> + grep -E -l '$(_gl_translatable_string_re)' $$files \
> + | $(SED) 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
> diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
> || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
> rm -f $@-1 $@-2; \
> @@ -1089,19 +1163,19 @@ sc_po_check:
>
> # Sometimes it is useful to change the PATH environment variable
> # in Makefiles. When doing so, it's better not to use the Unix-centric
> -# path separator of `:', but rather the automake-provided
> `$(PATH_SEPARATOR)'.
> -msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
> +# path separator of ':', but rather the automake-provided
> '$(PATH_SEPARATOR)'.
> +msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
> sc_makefile_path_separator_check:
> @prohibit='PATH[=].*:' \
> in_vc_files='akefile|\.mk$$' \
> halt=$(msg) \
> $(_sc_search_regexp)
>
> -# Check that `make alpha' will not fail at the end of the process,
> +# Check that 'make alpha' will not fail at the end of the process,
> # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
> # and is read-only.
> writable-files:
> - if test -d $(release_archive_dir); then \
> + $(AM_V_GEN)if test -d $(release_archive_dir); then \
> for file in $(DIST_ARCHIVES); do \
> for p in ./ $(release_archive_dir)/; do \
> test -e $$p$$file || continue; \
> @@ -1127,7 +1201,7 @@ sc_copyright_check:
> in_vc_files=$(sample-test) \
> halt='out of date copyright in $(sample-test); update it' \
> $(_sc_search_regexp)
> - @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
> + @require='Copyright @copyright\{\} .*'$$(date +%Y) \
> in_vc_files=$(texi) \
> halt='out of date copyright in $(texi); update it' \
> $(_sc_search_regexp)
> @@ -1159,6 +1233,16 @@ sc_cross_check_PATH_usage_in_tests:
> 1>&2; exit 1; } || :; \
> fi
>
> +# BRE regex of file contents to identify a test script.
> +_test_script_regex ?= \<init\.sh\>
> +
> +# In tests, use "compare expected actual", not the reverse.
> +sc_prohibit_reversed_compare_failure:
> + @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
> + containing='$(_test_script_regex)' \
> + halt='reversed compare arguments' \
> + $(_sc_search_regexp)
> +
> # #if HAVE_... will evaluate to false for any non numeric string.
> # That would be flagged by using -Wundef, however gnulib currently
> # tests many undefined macros, and so we can't enable that option.
> @@ -1173,22 +1257,31 @@ sc_Wundef_boolean:
> # not be constant, or might overflow a stack. In general, use PATH_MAX as
> # a limit, not an array or alloca size.
> sc_prohibit_path_max_allocation:
> - @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX' \
> + @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX' \
> halt='Avoid stack allocations of size PATH_MAX' \
> $(_sc_search_regexp)
>
> sc_vulnerable_makefile_CVE-2009-4029:
> @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
> - in_files=$$(find $(srcdir) -name Makefile.in) \
> + in_files='(^|/)Makefile\.in$$' \
> halt=$$(printf '%s\n' \
> 'the above files are vulnerable; beware of running' \
> ' "make dist*" rules, and upgrade to fixed automake' \
> ' see http://bugzilla.redhat.com/542609 for details') \
> $(_sc_search_regexp)
>
> +sc_vulnerable_makefile_CVE-2012-3386:
> + @prohibit='chmod a\+w \$$\(distdir\)' \
> + in_files='(^|/)Makefile\.in$$' \
> + halt=$$(printf '%s\n' \
> + 'the above files are vulnerable; beware of running' \
> + ' "make distcheck", and upgrade to fixed automake' \
> + ' see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
> + $(_sc_search_regexp)
> +
> vc-diff-check:
> - (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
> - if test -s vc-diffs; then \
> + $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
> + $(AM_V_at)if test -s vc-diffs; then \
> cat vc-diffs; \
> echo "Some files are locally modified:" 1>&2; \
> exit 1; \
> @@ -1199,46 +1292,62 @@ vc-diff-check:
> rel-files = $(DIST_ARCHIVES)
>
> gnulib_dir ?= $(srcdir)/gnulib
> -gnulib-version = $$(cd $(gnulib_dir) && git describe)
> +gnulib-version = $$(cd $(gnulib_dir) \
> + && { git describe || git rev-parse --short=10 HEAD; } )
> bootstrap-tools ?= autoconf,automake,gnulib
>
> +gpgv = $$(gpgv2 --version >/dev/null && echo gpgv2 || echo gpgv)
> # If it's not already specified, derive the GPG key ID from
> # the signed tag we've just applied to mark this release.
> -gpg_key_ID ?= \
> - $$(git cat-file tag v$(VERSION) > .ann-sig \
> - && gpgv .ann-sig - < /dev/null 2>&1 \
> - | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
> +gpg_key_ID ?= \
> + $$(cd $(srcdir) \
> + && git cat-file tag v$(VERSION) \
> + | $(gpgv) --status-fd 1 --keyring /dev/null - - 2>/dev/null \
> + | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
>
> translation_project_ ?= coordinator at translationproject.org
>
> # Make info-gnu the default only for a stable release.
> -ifeq ($(RELEASE_TYPE),stable)
> - announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
> - announcement_mail_headers_ ?= \
> - To: info-gnu at gnu.org \
> - Cc: $(announcement_Cc_) \
> - Mail-Followup-To: $(PACKAGE_BUGREPORT)
> -else
> - announcement_Cc_ ?= $(translation_project_)
> - announcement_mail_headers_ ?= \
> - To: $(PACKAGE_BUGREPORT) \
> - Cc: $(announcement_Cc_)
> -endif
> -
> +announcement_Cc_stable = $(translation_project_), $(PACKAGE_BUGREPORT)
> +announcement_mail_headers_stable = \
> + To: info-gnu at gnu.org \
> + Cc: $(announcement_Cc_) \
> + Mail-Followup-To: $(PACKAGE_BUGREPORT)
> +
> +announcement_Cc_alpha = $(translation_project_)
> +announcement_mail_headers_alpha = \
> + To: $(PACKAGE_BUGREPORT) \
> + Cc: $(announcement_Cc_)
> +
> +announcement_mail_Cc_beta = $(announcement_mail_Cc_alpha)
> +announcement_mail_headers_beta = $(announcement_mail_headers_alpha)
> +
> +announcement_mail_Cc_ ?= $(announcement_mail_Cc_$(release-type))
> +announcement_mail_headers_ ?= $(announcement_mail_headers_$(release-type))
> announcement: NEWS ChangeLog $(rel-files)
> - @$(srcdir)/$(_build-aux)/announce-gen \
> +# Not $(AM_V_GEN) since the output of this command serves as
> +# announcement message: it would start with " GEN announcement".
> + $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen \
> --mail-headers='$(announcement_mail_headers_)' \
> - --release-type=$(RELEASE_TYPE) \
> + --release-type=$(release-type) \
> --package=$(PACKAGE) \
> --prev=$(PREV_VERSION) \
> --curr=$(VERSION) \
> --gpg-key-id=$(gpg_key_ID) \
> + --srcdir=$(srcdir) \
> --news=$(srcdir)/NEWS \
> --bootstrap-tools=$(bootstrap-tools) \
> - --gnulib-version=$(gnulib-version) \
> + $$(case ,$(bootstrap-tools), in (*,gnulib,*) \
> + echo --gnulib-version=$(gnulib-version);; esac) \
> --no-print-checksums \
> $(addprefix --url-dir=, $(url_dir_list))
>
> +.PHONY: release-commit
> +release-commit:
> + $(AM_V_GEN)cd $(srcdir) \
> + && $(_build-aux)/do-release-commit-and-tag \
> + -C $(abs_builddir) $(RELEASE)
> +
> ## ---------------- ##
> ## Updating files. ##
> ## ---------------- ##
> @@ -1247,16 +1356,22 @@ ftp-gnu = ftp://ftp.gnu.org/gnu
> www-gnu = http://www.gnu.org
>
> upload_dest_dir_ ?= $(PACKAGE)
> +upload_command = \
> + $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \
> + --to $(gnu_rel_host):$(upload_dest_dir_) \
> + $(rel-files)
> emit_upload_commands:
> @echo =====================================
> @echo =====================================
> - @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
> - @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
> - @echo " $(rel-files)"
> + @echo '$(upload_command)'
> @echo '# send the ~/announce-$(my_distdir) e-mail'
> @echo =====================================
> @echo =====================================
>
> +.PHONY: upload
> +upload:
> + $(AM_V_GEN)$(upload_command)
> +
> define emit-commit-log
> printf '%s\n' 'maint: post-release administrivia' '' \
> '* NEWS: Add header line for next release.' \
> @@ -1266,7 +1381,8 @@ endef
>
> .PHONY: no-submodule-changes
> no-submodule-changes:
> - if test -d $(srcdir)/.git; then \
> + $(AM_V_GEN)if test -d $(srcdir)/.git \
> + && git --version >/dev/null 2>&1; then \
> diff=$$(cd $(srcdir) && git submodule -q foreach \
> git diff-index --name-only HEAD) \
> || exit 1; \
> @@ -1284,10 +1400,12 @@ submodule-checks ?= no-submodule-changes
> public-submodule-commit
> # cannot be built from a fresh clone.
> .PHONY: public-submodule-commit
> public-submodule-commit:
> - $(AM_V_GEN)if test -d $(srcdir)/.git; then \
> + $(AM_V_GEN)if test -d $(srcdir)/.git \
> + && git --version >/dev/null 2>&1; then \
> cd $(srcdir) && \
> - git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
> - = '$$(git merge-base origin $$sha1)' \
> + git submodule --quiet foreach \
> + 'test "$$(git rev-parse "$$sha1")" \
> + = "$$(git merge-base origin "$$sha1")"' \
> || { echo '$(ME): found non-public submodule commit' >&2; \
> exit 1; }; \
> else \
> @@ -1302,19 +1420,23 @@ public-submodule-commit:
> gl_public_submodule_commit ?= public-submodule-commit
> check: $(gl_public_submodule_commit)
>
> -.PHONY: alpha beta stable
> +.PHONY: alpha beta stable release
> ALL_RECURSIVE_TARGETS += alpha beta stable
> alpha beta stable: $(local-check) writable-files $(submodule-checks)
> - test $@ = stable \
> + $(AM_V_GEN)test $@ = stable \
> && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
> || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
> || :
> - $(MAKE) vc-diff-check
> - $(MAKE) news-check
> - $(MAKE) distcheck
> - $(MAKE) dist XZ_OPT=-9ev
> - $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
> - $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
> + $(AM_V_at)$(MAKE) vc-diff-check
> + $(AM_V_at)$(MAKE) news-check
> + $(AM_V_at)$(MAKE) distcheck
> + $(AM_V_at)$(MAKE) dist
> + $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
> + $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
> +
> +release:
> + $(AM_V_GEN)$(MAKE) _version
> + $(AM_V_GEN)$(MAKE) $(release-type)
>
> # Override this in cfg.mk if you follow different procedures.
> release-prep-hook ?= release-prep
> @@ -1322,19 +1444,19 @@ release-prep-hook ?= release-prep
> gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
> .PHONY: release-prep
> release-prep:
> - case $$RELEASE_TYPE in alpha|beta|stable) ;; \
> - *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
> - $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
> - if test -d $(release_archive_dir); then \
> + $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
> + > ~/announce-$(my_distdir)
> + $(AM_V_at)if test -d $(release_archive_dir); then \
> ln $(rel-files) $(release_archive_dir); \
> chmod a-w $(rel-files); \
> fi
> - echo $(VERSION) > $(prev_version_file)
> - $(MAKE) update-NEWS-hash
> - perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
> - $(emit-commit-log) > .ci-msg
> - $(VC) commit -F .ci-msg -a
> - rm .ci-msg
> + $(AM_V_at)echo $(VERSION) > $(prev_version_file)
> + $(AM_V_at)$(MAKE) update-NEWS-hash
> + $(AM_V_at)perl -pi \
> + -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' \
> + $(srcdir)/NEWS
> + $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1; \
> + cd $(srcdir) && $(VC) commit -m "$$msg" -a
>
> # Override this with e.g., -s $(srcdir)/some_other_name.texi
> # if the default $(PACKAGE)-derived name doesn't apply.
> @@ -1342,14 +1464,20 @@ gendocs_options_ ?=
>
> .PHONY: web-manual
> web-manual:
> - @test -z "$(manual_title)" \
> + $(AM_V_GEN)test -z "$(manual_title)" \
> && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
> - @cd '$(srcdir)/doc'; \
> + $(AM_V_at)cd '$(srcdir)/doc'; \
> $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
> -o '$(abs_builddir)/doc/manual' \
> --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
> "$(PACKAGE_NAME) - $(manual_title)"
> - @echo " *** Upload the doc/manual directory to web-cvs."
> + $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
> +
> +.PHONY: web-manual-update
> +web-manual-update:
> + $(AM_V_GEN)cd $(srcdir) \
> + && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
> +
>
> # Code Coverage
>
> @@ -1375,6 +1503,31 @@ gen-coverage:
>
> coverage: init-coverage build-coverage gen-coverage
>
> +# Some projects carry local adjustments for gnulib modules via patches in
> +# a gnulib patch directory whose default name is gl/ (defined in bootstrap
> +# via local_gl_dir=gl). Those patches become stale as the originals evolve
> +# in gnulib. Use this rule to refresh any stale patches. It applies each
> +# patch to the original in $(gnulib_dir) and uses the temporary result to
> +# generate a fuzz-free .diff file. If you customize the name of your local
> +# gnulib patch directory via bootstrap.conf, this rule detects that name.
> +# Run this from a non-VPATH (i.e., srcdir) build directory.
> +.PHONY: refresh-gnulib-patches
> +refresh-gnulib-patches:
> + gl=gl; \
> + if test -f bootstrap.conf; then \
> + t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;' \
> + -e 'END{defined $$d and print $$d}' bootstrap.conf); \
> + test -n "$$t" && gl=$$t; \
> + fi; \
> + for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do \
> + b=$$(printf %s "$$diff"|$(SED) 's/\.diff$$//'); \
> + VERSION_CONTROL=none \
> + patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1; \
> + ( cd $(gnulib_dir) || exit 1; \
> + git diff "$$b" > "../$$gl/$$diff"; \
> + git checkout $$b ) || exit 1; \
> + done
> +
> # Update gettext files.
> PACKAGE ?= $(shell basename $(PWD))
> PO_DOMAIN ?= $(PACKAGE)
> @@ -1386,7 +1539,8 @@ refresh-po:
> wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive
> --level 1 --accept .po --accept .po.1 $(POURL) && \
> echo 'en at boldquot' > $(PODIR)/LINGUAS && \
> echo 'en at quot' >> $(PODIR)/LINGUAS && \
> - ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >>
> $(PODIR)/LINGUAS
> + ls $(PODIR)/*.po | $(SED) 's/\.po//;s,$(PODIR)/,,' | \
> + sort >> $(PODIR)/LINGUAS
>
> # Running indent once is not idempotent, but running it twice is.
> INDENT_SOURCES ?= $(C_SOURCES)
> @@ -1408,7 +1562,7 @@ update-copyright-env ?=
> # in the file .x-update-copyright.
> .PHONY: update-copyright
> update-copyright:
> - grep -l -w Copyright \
> + $(AM_V_GEN)grep -l -w Copyright \
> $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
> | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
>
> @@ -1440,28 +1594,28 @@ sc_tight_scope: tight-scope.mk
>
> tight-scope.mk: $(ME)
> @rm -f $@ $@-t
> - @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(ME) > $@-t
> + @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
> @chmod a=r $@-t && mv $@-t $@
>
> ifeq (a,b)
> # TS-start
>
> # Most functions should have static scope.
> -# Any that don't must be marked with `extern', but `main'
> -# and `usage' are exceptions: they're always extern, but
> -# do not need to be marked. Symbols matching `__.*' are
> +# Any that don't must be marked with 'extern', but 'main'
> +# and 'usage' are exceptions: they're always extern, but
> +# do not need to be marked. Symbols matching '__.*' are
> # reserved by the compiler, so are automatically excluded below.
> _gl_TS_unmarked_extern_functions ?= main usage
> -_gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
> +_gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\w+) *\(/
>
> # If your project uses a macro like "XTERN", then put
> # the following in cfg.mk to override this default:
> # export _gl_TS_extern = extern|XTERN
> _gl_TS_extern ?= extern
>
> -# The second nm|grep checks for file-scope variables with `extern' scope.
> +# The second nm|grep checks for file-scope variables with 'extern' scope.
> # Without gnulib's progname module, you might put program_name here.
> -# Symbols matching `__.*' are reserved by the compiler,
> +# Symbols matching '__.*' are reserved by the compiler,
> # so are automatically excluded below.
> _gl_TS_unmarked_extern_vars ?=
>
> @@ -1481,9 +1635,11 @@ _gl_TS_obj_files ?= *.$(OBJEXT)
> # Files in which to search for the one-line style extern declarations.
> # $(_gl_TS_dir)-relative.
> _gl_TS_headers ?= $(noinst_HEADERS)
> +_gl_TS_other_headers ?= *.h
>
> .PHONY: _gl_tight_scope
> _gl_tight_scope: $(bin_PROGRAMS)
> + sed_wrap='s/^/^_?/;s/$$/$$/'; \
> t=exceptions-$$$$; \
> trap 's=$$?; rm -f $$t; exit $$s' 0; \
> for sig in 1 2 3 13 15; do \
> @@ -1493,19 +1649,20 @@ _gl_tight_scope: $(bin_PROGRAMS)
> test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
> hdr=`for f in $(_gl_TS_headers); do \
> test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
> - ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
> + ( printf '%s\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
> grep -h -A1 '^extern .*[^;]$$' $$src \
> - | grep -vE '^(extern |--)' | sed 's/ .*//'; \
> + | grep -vE '^(extern |--|#)' | $(SED) 's/ .*//; /^$$/d'; \
> perl -lne \
> - '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
> - ) | sort -u > $$t; \
> - nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
> + '$(_gl_TS_function_match) and print $$1' $$hdr; \
> + ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
> + nm -g $(_gl_TS_obj_files)|$(SED) -n 's/.* T //p'|grep -Ev -f $$t \
> && { echo the above functions should have static scope >&2; \
> exit 1; } || : ; \
> - ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
> - perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
> - ) | sort -u > $$t; \
> - nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p' \
> + ( printf '%s\n' '__.*' main $(_gl_TS_unmarked_extern_vars); \
> + perl -lne '$(_gl_TS_var_match) and print $$1' \
> + $$hdr $(_gl_TS_other_headers) \
> + ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
> + nm -g $(_gl_TS_obj_files) | $(SED) -n 's/.* [BCDGRS] //p' \
> | sort -u | grep -Ev -f $$t \
> && { echo the above variables should have static scope >&2; \
> exit 1; } || :
Acked-by: Frediano Ziglio <fziglio at redhat.com>
I don't think this should cause test problem but I'll wait Christophe
before merging it.
Frediano
More information about the Spice-devel
mailing list